#include <iostream>
#include <unordered_map>
using namespace std;

int calculateMinPresses(string message, unordered_map<char, int>& brokenKeys) {
    int presses = 0;
    unordered_map<char, int> consecutiveFailures;

    for (char c : message) {
        if (brokenKeys.count(c) > 0) {
            int frequency = brokenKeys[c];
            consecutiveFailures[c]++;

            if (consecutiveFailures[c] % frequency == 0) {
                presses++;
            }
        }
        presses++;
    }

    return presses;
}
int main() {
    string message;
    cin >> message;

    int n;
    cin >> n;

    unordered_map<char, int> brokenKeys;
    for (int i = 0; i < n; i++) {
        char c;
        int frequency;
        cin >> c >> frequency;
        brokenKeys[c] = frequency - 1;
    }

    int minPresses = calculateMinPresses(message, brokenKeys);
    cout << minPresses << endl;

    return 0;
}
