//  Nikita Golikov, 2023

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
  #include "/Users/golikovnik/contests/debug.h"
#else
  #define debug(...) ;
#endif

template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

//  w - vertices, d - edges
ll solve(vector<int> w, vector<int> d) {
  int n = int(w.size());
  assert(n == int(d.size()));
  ll ans = 0;
  smax(ans, accumulate(d.begin(), d.end(), 0ll) - accumulate(w.begin(), w.end(), 0ll));

  auto solve = [&] {
    vector<ll> dp(n + 1);
    for (int i = 0; i < n; ++i) {
      smax(dp[i + 1], dp[i]);
      ll cur = -w[i];
      for (int j = i + 1; j < n; ++j) {
        cur += d[j - 1];
        cur -= w[j];
        smax(dp[j + 1], dp[i] + cur);
      }
    }
    return dp[n];
  };

  for (int st = 0; st < n; ++st) {
    smax(ans, solve());
    d.push_back(d[0]);
    d.erase(d.begin());
    w.push_back(w[0]);
    w.erase(w.begin());
  }

  return ans;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, q;
  cin >> n >> q;
  vector<int> w(n), d(n - 1);
  for (int& x : w) {
    cin >> x;
  }
  for (int& x : d) {
    cin >> x;
  }
  while (q--) {
    int t; cin >> t;
    if (t == 1) {
      int i, x;
      cin >> i >> x;
      w[i - 1] = x;
    } else if (t == 2) {
      int i, x;
      cin >> i >> x;
      d[i - 1] = x;
    } else {
      int l, r, x;
      cin >> l >> r >> x;
      --l;
      assert(r - l >= 2);
      vector<int> qw(w.begin() + l, w.begin() + r);
      vector<int> qd(d.begin() + l, d.begin() + (r - 1));
      qd.push_back(x);
      cout << solve(qw, qd) << '\n';
    }
  }

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
