#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const char en = '\n';

template<typename T>
int sz(T x) { return (int)x.size(); }

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 42
#endif

template<typename T>
struct Fenwick {
    int n;
    vector<T> f;

    Fenwick(int _n) {
        n = _n;
        f.assign(n + 1, 0);
    }

    void update(int x, T delta) {
        for (int i = x; i <= n; i += i & -i) {
            f[i] += delta;
        }
    }

    T get_sum(int x) {
        T s = 0;
        for (int i = x; i > 0; i -= i & -i) {
            s += f[i];
        }
        return s;
    }

    T get(int L, int R) { // [L, R]
        return get_sum(R) - get_sum(L - 1);
    }
};


void solve() {
    int n;
    string s;
    int q;
    cin >> n >> s >> q;
    Fenwick<int> ft(n);
    for (int i = 0; i < n; ++i) {
        if (s[i] == 'a') {
            ft.update(i + 1, 1);
        }
    }
    for (int w = 0; w < q; ++w) {
        int type;
        cin >> type;
        if (type == 1) {
            int i;
            cin >> i;
            --i;
            if (s[i] == 'a') {
                ft.update(i + 1, -1);
                s[i] = 'b';
            } else {
                ft.update(i + 1, 1);
                s[i] = 'a';
            }
        } else {
            int l, r;
            cin >> l >> r;
            --l;
            bool ok = true;
            for (int i = l; i < r; ++i) {
                if (s[i] == 'b' && (i == l || s[i - 1] == 'b')) {
                    for (int j = i; j < r; ++j) {
                        if (s[j] == 'b' && (j + 1 == r || s[j + 1] == 'b')) {
                            int len = j - i + 1;
                            int cnt_a = ft.get(i + 1, j + 1);
                            int cnt_b = len - cnt_a;
                            if (cnt_a < cnt_b) {
                                ok = false;
                            }
                        }
                    }
                }
            }
            cout << (ok ? "YES" : "NO") << en;
        }
    }
}

int32_t main() {
#ifdef THEEVILBIRD
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}
