#include<bits/stdc++.h>

using namespace std;
using ll = long long;

template<typename T>
struct SparseTable {
    vector<vector<T>> st;
    T (*func)(T, T);
    ll len;
    void init(vector<T> a, T (*f)(T, T)) {
        func = f;
        len = (ll)a.size();
        ll mxpw = 32 - __builtin_clz(len);
        st.resize(mxpw);
        st[0] = a;
        for(ll k = 1; k < mxpw; k++) {
            st[k].resize(len - (1 << k) + 1);
            for(ll i = 0; i < (ll)st[k].size(); i++)
                st[k][i] = func(st[k - 1][i], st[k - 1][i + (1 << k - 1)]);
        }
    }
    T get(ll l, ll r) {
        ll k = 31 - __builtin_clz(r - l + 1);
        return func(st[k][l], st[k][r - (1 << k) + 1]);
    }
};

const ll N = 2e5;
ll ch[N + 1];
ll dist[N + 1];
ll tin[N + 1];
ll tout[N + 1];
ll cnt;
vector<ll> all[N + 1];
SparseTable<ll> st[N + 10];
vector<ll> gr[N + 1];

void build_dfs(ll city) {
    tin[city] = ++cnt;
    ch[city] = 1e9;
    all[dist[city]].push_back(city);
    for (ll i : gr[city]) {
        dist[i] = dist[city] + 1;
        build_dfs(i);
        ch[city] = min(1 + ch[i], ch[city]);
    }
    tout[city] = ++cnt;
    if (ch[city] == 1e9)
        ch[city] = 0;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    vector<ll> a = {2, 3};
    ll n;
    cin >> n;
    for (ll i = 2; i <= n; ++i) {
        ll p;
        cin >> p;
        gr[p].push_back(i);
    }
    build_dfs(1);
    ll res = 0;
    for (ll dep = n - 1; dep >= 0; --dep) {
        vector<ll> dp;
        for (ll j : all[dep]) {
            ll ans = 0, next = dep + ch[j];
            if (next != dep) {
                ll l1 = -1, r1 = all[next].size();
                while (l1 + 1 < r1) {
                    ll mid = (l1 + r1) >> 1;
                    if (tin[j] <= tin[all[next][mid]])
                        r1 = mid;
                    else
                        l1 = mid;
                }
                ll l2 = -1, r2 = all[next].size();
                while (l2 + 1 < r2) {
                    ll mid = (l2 + r2) >> 1;
                    if (tin[all[next][mid]]<= tout[j])
                        l2 = mid;
                    else
                        r2 = mid;
                }
                if (r1 <= l2)
                    ans = 1 + st[next].get(r1, l2);
                ///r1 l2
            }
            dp.push_back(ans);
            if(!dep) res = dp.back();
        }
        st[dep].init(dp, [](ll x, ll  y) {return (x > y ? x : y);});
    }
    cout << res;
    return 0;
}
