#include <iostream>
#include <cmath>
#include <set>
#include <vector>
#include <algorithm>

using namespace std;

template<typename T, typename C>
pair<T, T> bin_search(T from, T to, C c)
{
	while (to - from > 1)
	{
		T mid = from + (to - from) / 2;

		if (c(mid))
		{
			to = mid;
		}
		else
		{
			from = mid;
		}
	}
}

int f(int i, const vector<set<int>>& v, const vector<int>& d, int l = 0)
{
	int r = -1;

	if (l)
	{
		for (int e : v[i])
		{
			r = max(r, f(e, v, d, l - 1));
		}
	}
	else
	{
		for (int e : v[i])
		{
			r = max(r, f(e, v, d, d[i] - 1));
		}

		r++;
	}

	return r;
}

int main()
{
	int n;

	cin >> n;

	vector<set<int>> v(n);
	vector<int> d(n);

	for (int i = 1; i < n; i++)
	{
		int t;

		cin >> t;

		t--;

		v[t].insert(i);
	}

	for (int i = n - 1; i >= 0; i--)
	{
		d[i] = v[i].empty() ? 0 : 10000000;

		for (int e : v[i])
		{
			d[i] = min(d[i], d[e] + 1);
		}
	}

	cout << f(0, v, d);
}