#include <iostream>
#include <vector>
#include <map>
#include <string>

using namespace std;

using ll = long long;


template <typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (T& x : a) in >> x;
    return in;
}

string SEP = " ";

template <typename T>
ostream& operator<<(ostream& out, vector<T> a) {
    for (T& x : a) out << x << SEP;
    return out;
}

ll n;
map<ll, ll> chec_map;

bool check(ll d, ll add_n){
    ll new_n;
    if(chec_map.find(d) == chec_map.end()) {
        cout << "? " << d << endl;
        cin >> new_n;
        chec_map[d] = new_n;
    } else {
        new_n = chec_map[d];
    }
    return new_n >= n + add_n;
}

ll get_d(ll add_n){
    ll l = 0, r = 2;
    while(!check(r, add_n)) r *= 2;
    while(r - l > 1){
        ll mid = (l + r) / 2;
        if(check(mid, add_n)) r = mid;
        else l = mid;
    }
    return r;
}

ll serge(ll n, ll k){
    if(k == 0) return 1;
    ll val = serge(n, k / 2);
    if(k % 2 == 0) return val * val;
    return serge(n,k-1)*n;
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);

    cin >> n;
    ll d1 = get_d(1);
    ll d2 = get_d(2);
    ll d3 = get_d(3);

    ll b = (d3 - d2) / (d2 - d1);
    ll x = serge(b, n) - d1;

    cout << "! " << x << ' ' << b << endl;
    return ('U' ^ 'U');
}
