#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()

#define int long long

const int m = 1e9 + 7;

int binpow(int a, int n) {
    if (n == 0) return 1;
    if (n & 1) return (a * binpow(a, n - 1)) % m;
    else {
        int b = binpow(a, n / 2);
        return b * b % m;
    }
}

int fact(int n) {
    if (n == 0) return 1;
    int ans = 1;
    for (int i = 2; i <= n; ++i) {
        ans = ans * i % m;
    }
    return ans;
}

int pow2(int a, int n) {
    int ans = 1;
    for (int i = 0; i < n; ++i) {
        ans = ans * a % m;
    }
    return ans;
}

struct Node {
    int cp, cs, len;
    bool was;

    Node() {
        cp = cs = len = 0;
        was = false;
    }
};

Node get_node(char c) {
    Node m;
    m.was = false;
    m.cp = m.cs = (c == 'b');
    m.len = 1;
    return m;
}

Node combine(Node l, Node r) {
    Node m;
    m.cp = l.cp + (l.cp == l.len ? r.cp : 0);
    m.cs = r.cs + (r.cs == r.len ? l.cs : 0);
    m.len = r.len + l.len;
    m.was = l.was | r.was | (l.cs + r.cp >= 3);
    return m;
}

vector<Node> t;

void build(int u, int tl, int tr, string &s) {
    if (tl + 1 == tr) {
        t[u] = get_node(s[tl]);
        return;
    }
    int tm = (tl + tr) / 2;
    build(2 * u + 1, tl, tm, s);
    build(2 * u + 2, tm, tr, s);
    t[u] = combine(t[2 * u + 1], t[2 * u + 2]);
}

Node query(int u, int tl, int tr, int l, int r) {
    if (r <= tl || tr <= l)
        return Node();
    if (l <= tl && tr <= r)
        return t[u];
    int tm = (tl + tr) / 2;
    return combine(
            query(2 * u + 1, tl, tm, l, r),
            query(2 * u + 2, tm, tr, l, r)
    );
}

void update(int u, int tl, int tr, int pos) {
    if (tl + 1 == tr) {
        t[u].cs = t[u].cp = (int) (!t[u].cs);
        return;
    }
    int tm = (tl + tr) / 2;
    if (pos < tm) update(2 * u + 1, tl, tm, pos);
    else update(2 * u + 2, tm, tr, pos);
    t[u] = combine(t[2 * u + 1], t[2 * u + 2]);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
//    int n;
//    cin >> n;
//    int ind = 1;
//    int q;
//    vector<vector<int>> arr(n + 1, vector<int>(3));
//    string str;
//    while (ind < n) {
//        cout << ind << ' ' << "ab" << endl;
//        cin >> q;
//        if (q == 2) {
//            str += "ab";
//            cout << ind + 1 << ' ' << "bc" << endl;
//            cin >> q;
//            if (q == 2) {
//                str += "c";
//            } else {
//                cout << ind + 1 << ' ' << "bb" << endl;
//                cin >> q;
//                if (q == 2) {
//                    str += "b";
//                } else {
//                    str += "a";
//                }
//            }
//        } else if (q == 1) {
//            int q1;
//            cout << ind + 1 << ' ' << "ba" << endl;
//            cin >> q;
//            if (q == 0) {
//                cout << ind + 1 << ' ' << "ab" << endl;
//                cin >> q;
//                if (q == 0) {
//                    str += "acc";
//                } else if (q == 1) {
//                    cout << ind + 1 << ' ' << "ac" << endl;
//                    cin >> q;
//                    if (q == 0) {
//                        str += "acb";
//                    } else if (q == 2) {
//                        str += "aac";
//                    }
//                } else {
//                    str += "aab";
//                }
//            }
//            if (q == 1) {
//                cout << ind + 1 << ' ' << "bc" << endl;
//                cin >> q;
//                if (q == 0) {
//                    cout << ind + 1 << ' ' << "ca" << endl;
//                    cin >> q;
//                    if (q == 1) str += "aaa";
//                    else if (q == 1)str += "aca";
//                } else if (q == 2) {
//                    cout << ind << ' ' << "bb" << endl;
//                    cin >> q;
//                    if (q == 1) str += "cbc";
//                    else if (q == 2) str += "bbc";
//                } else {
//                    cout << ind << ' ' << "cb" << endl;
//                    cin >> q;
//                    if (q == 1) str += "bbb";
//                    else if (q == 2) str += "cbb";
//                }
//            }
//        }
//
//    }
    int n;
    cin >> n;
    vector <int> a(n);
    vector <int> cl(3);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i] %= 3;
        cl[a[i]]++;
    }


    int z = cl[0];
    int ed = cl[1];
    int dv = cl[2];

    if (abs(ed - dv) >= 1 && abs(ed - dv) <= 2) {
        cout << (fact(n - 1) * fact(ed) % m * fact(dv) % m) * binpow(fact(ed + dv - 1), m - 2) % m;
    } else {
        cout << 0;
    }
    return 0;
}
