#include "bits/stdc++.h"

using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}
const ll MOD = 1e9+7;

struct Point{
    ll x, y;
    Point() : x(0), y(0) {}
    Point(ll x, ll y) : x(x), y(y) {}
    ll sign() const {
        if (x > 0) return 1;
        if (x < 0) return -1;
        if (y > 0) return 1;
        else return -1;
    }
    Point operator-(const Point& a) const{
        return Point(x - a.x, y - a.y);
    }
    ll operator%(const Point& a) const{
        return x * a.y - y * a.x;
    }
    Point operator-() const{
        return Point(-x, -y);
    }
};

void dfs(ll v, vector<vector<ll>>& g, vector<ll>& used, ll sv, ll& ans){
    used[v] = 1;
    for (ll u : g[v]){
        if (!used[u]){
            if (sv) ans++;
            dfs(u, g, used, sv ^ 1, ans);
        }
    }
}

void solve() {
    ll n;
    cin >> n;
    vector<Point> a(n);
    for (ll i = 0;i<n;i++) {
        cin >> a[i].x >> a[i].y;
    }
    vector<vector<ll>> g(n);
    ll res = n-1;
    for (ll i =0;i<n-1;i++){
        ll u, v;
        cin >> u >> v;
        g[u-1].push_back(v-1);
        g[v-1].push_back(u-1);
    }
    for (ll v = 0;v<n;v++){
        vector<Point> f;
        for (ll u : g[v]){
            f.push_back(a[u]-a[v]);
        }
        sort(all(f), [](Point a, Point b){
            if (a.sign() != b.sign()) return a.sign() > b.sign();
            return (a % b) > 0;
        });
        ll m =f.size();
        vector<vector<ll>> gov(m);
        for (ll i = 0;i<m;i++){
            ll u = lower_bound(all(f), -f[i], [](Point a, Point b){
                if (a.sign() != b.sign()) return a.sign() > b.sign();
                return (a % b) > 0;
            }) - f.begin();
            if (f[u % m] % f[i] == 0 && u % m != i) gov[i] = {u % m};
            else{
                gov[i] = {u % m, (u + m - 1) % m};
            }
        }
        vector<vector<ll>> g(m);
        for (ll v = 0;v<m;v++){
            for (ll u : gov[v]){
                if (u == v) continue;
                for (ll x : gov[u]) {
                    if (x == v){
                        g[v].push_back(u);
                        break;
                    }
                }
            }
        }
        vector<ll> used(m, 0);
        ll ans = 0;
        for (ll i =  0;i<m;i++){
            if (g[i].size() == 1 && !used[i]) dfs(i, g, used, 1, ans);
        }
        for (ll i = 0;i<m;i++){
            if (!used[i]) dfs(i, g, used, 1, ans);
        }
        res-=ans;
    }
    cout << res << "\n";
}
