#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <unordered_map>

using namespace std;

typedef long long ll;

const int maxn = 2e5;
vector<vector<int>> gr(maxn);
vector<int> h(maxn), mn(maxn), sz(maxn, 1), sl(maxn), d(maxn);

vector<unordered_map<int, int>> tt(maxn);

void dfs(int v,int hg = 0) {
	if (gr[v].empty()) {
		mn[v] = hg;
		h[v] = hg;
		return;
	}
	h[v] = hg;
	mn[v] = 1e9;
	for (auto u : gr[v]) {
		dfs(u, hg + 1);
		mn[v] = min(mn[v], mn[u]);
		sz[v] += sz[u];
	}
}

void dp(int v) {
	for (int i = 1; i < gr[v].size(); ++i) {
		if (sz[gr[v][i]] > sz[gr[v][0]]) {
			swap(gr[v][i], gr[v][0]);
		}
	}
	if (!gr[v].empty()) {
		sl[v] = sl[gr[v][0]];
	}
	for (auto u : gr[v]) {
		dp(u);
		if (u != gr[v][0]) {
			for (auto y : tt[sl[u]]) {
				tt[sl[v]][y.first] = max(tt[sl[v]][y.first], y.second);
			}
		}
	}
	d[v] = tt[sl[v]][mn[v]] + 1;
	tt[sl[v]][h[v]] = max(tt[sl[v]][h[v]], d[v]);
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);
	
	int n;
	cin >> n;
	for (int i = 1; i < n; ++i) {
		sl[i] = i;
		int p;
		cin >> p;
		--p;
		gr[p].push_back(i);
	}
	dfs(0);
	dp(0);
	cout << d[0];
	return 0;
}