#include <bits/stdc++.h>

#ifndef LOCAL
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,strict-overflow")
#pragma GCC target("sse4.2,avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#endif

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using pdd = pair<double, double>;
using pii = pair<int, int>;

#define inf 1'000'001'000

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n;
    cin >> n;
    pii min_row = {inf, -1};
    pii max_row = {-inf, -1};
    pii min_col = {inf, -1};
    pii max_col = {-inf, -1};
    vector<vector<int>> matrix(n, vector<int>(n));
    vector<ll> col_sums(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> matrix[i][j];
        }
    }
    for (int i = 0; i < n; ++i) {
        ll row_sum = 0;
        ll col_sum = 0;
        for (int j = 0; j < n; ++j) {
            row_sum += matrix[i][j];
            col_sum += matrix[j][i];
        }
        min_row = min(min_row, {row_sum, i});
        max_row = max(max_row, {row_sum, i});
        min_col = min(min_col, {col_sum, i});
        max_col = max(max_col, {col_sum, i});
    }
    if (min_row.first == max_row.first) {
        // Same row
        int col1 = min_col.second;
        int col2 = max_col.second;
        for (int i = 0; i < n; ++i) {
            if (matrix[i][col1] * 2 + min_col.first == matrix[i][col2] * 2 + max_col.first) {
                cout << i + 1 << " " << col1 + 1 << "\n";
                cout << i + 1 << " " << col2 + 1 << "\n";
                return 0;
            }
            if (matrix[i][col1] * 2 + max_col.first == matrix[i][col2] * 2 + min_col.first) {
                cout << i + 1 << " " << col1 + 1 << "\n";
                cout << i + 1 << " " << col2 + 1 << "\n";
                return 0;
            }
        }
    }
    if (min_col.first == max_col.first) {
        // Same col
        int row1 = min_row.second;
        int row2 = max_row.second;
        for (int i = 0; i < n; ++i) {
            if (matrix[row1][i] * 2 + min_row.first == matrix[row2][i] * 2 + max_row.first) {
                cout << row1 + 1 << " " << i + 1 << "\n";
                cout << row2 + 1 << " " << i + 1 << "\n";
                return 0;
            }
            if (matrix[row1][i] * 2 + max_row.first == matrix[row2][i] * 2 + min_row.first) {
                cout << row1 + 1 << " " << i + 1 << "\n";
                cout << row2 + 1 << " " << i + 1 << "\n";
                return 0;
            }
        }
    }
    cout << min_row.second + 1 << " " << min_col.second + 1 << "\n";
    cout << max_row.second + 1 << " " << max_col.second + 1 << "\n";
}
