#include <iostream>
#include <vector>
#include <map>

using namespace std;

using ll = long long;

int MAXN = 2e5;
int INF = 1e9;

int time = 0;

vector<vector<int>> g(MAXN);
vector<int> nearestLeaf(MAXN, INF);
map<int, vector<int>> depth;
vector<int> ranks(MAXN, 0);
vector<int> opt(MAXN, 0);
vector<int> tin(MAXN, 0), tout(MAXN, 0);

void findNearestLeaf(int x) {
    for (auto& i : g[x]) {
        findNearestLeaf(i);
        nearestLeaf[x] = min(nearestLeaf[x], nearestLeaf[i] + 1);
    }
    if (nearestLeaf[x] == INF) nearestLeaf[x] = 0;
}

void findDepth(int x, int c) {
    ranks[x] = c;
    depth[c].emplace_back(x);
    for (auto& i : g[x]) {
        findDepth(i, c + 1);
    }
}

void findTinTout(int x) {
    tin[x] = time;
    for (auto& i : g[x]) {
        time++;
        findTinTout(i);
    }
    time++;
    tout[x] = time;
    time++;
}

void findOpt(int x) {
    for (auto& i : g[x]) {
        findOpt(i);
    }

    int n = nearestLeaf[x];
    int t = ranks[x];

    for (auto& i : depth[t + n]) {
        if (opt[i] + 1 > opt[x] && (tin[i] > tin[x] && tout[i] < tout[x]) && !g[i].empty()) {
            opt[x] = opt[i] + 1;
        }
    }

    if (!g[x].empty()) {
        opt[x] = max(opt[x], 1);
    }
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int n;
	cin >> n;

	for (int i = 1; i < n; ++i) {
        int x;
        cin >> x;
        x--;
        g[x].emplace_back(i);
	}

	findNearestLeaf(0);
	findDepth(0, 0);
	findTinTout(0);
	findOpt(0);

	cout << opt[0];

	return 0;
}
