#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

using ll = long long;

ll mod = 1e9 + 7;

vector<vector<ll>> cache(5001, vector<ll>(5001, -1));

ll get(ll cnt1, ll cnt2) {
	if (cnt1 < 0) return 0ll;
	if (cache[cnt1][cnt2] != -1) {
		return cache[cnt1][cnt2];
	}
	if (cnt2 == 0) return (cnt1 == 0);

	cache[cnt1][cnt2] = (get(cnt1, cnt2 - 1) + get(cnt1 - 1, cnt2 - 1) + get(cnt1 - 2, cnt2 - 1)) % mod;
	return cache[cnt1][cnt2];
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	ll n;
	cin >> n;

	vector<ll> dp(n + 1);
	dp[1] = 1;

	for (ll i = 2; i <= n; ++i) {
		dp[i] = dp[i - 1] * get(i, i - 1);
		dp[i] %= mod;
	}

	cout << dp[n] << '\n';

	return 0;
}
