#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

using ll = long long;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int n;
	cin >> n;

	vector<vector<ll>> a(n, vector<ll>(n));
	for (auto& i : a) for (auto& j : i) cin >> j;

	vector<ll> rows(n, 0);
	vector<ll> columns(n, 0);

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			rows[i] += a[i][j];
			columns[j] += a[i][j];
		}
	}

	ll avg = (n * n) * (n * n + 1) / 2 / n;

	map<ll, int> wrongRows;
	map<ll, int> wrongColumns;

	for (int i = 0; i < n; ++i) {
		if (rows[i] != avg) {
			wrongRows[rows[i]] = i;
		}
		if (columns[i] != avg) {
			wrongColumns[columns[i]] = i;
		}
	}

	auto it1 = wrongRows.begin();
	auto it2 = wrongColumns.begin();

	cout << it1->second + 1 << ' ' << it2->second + 1 << '\n';
	it1++;
	it2++;
	cout << it1->second + 1 << ' ' << it2->second + 1 << '\n';

	return 0;
}