#include<bits/stdc++.h>
using namespace std;

int mod = 1e9 + 7;

int add(int a, int b) {
    return a + b >= mod ? a +  b - mod : a + b;
}

int sub(int a, int b) {
    return a >= b ? a - b : a + mod - b;
}

int mul(int a, int b) {
    return 1ll * a * b % mod;
}

int binpow(int a, int n) {
    int res = 1;
    for (; n; n >>= 1) {
        if (n & 1) res = mul(res, a);
        a = mul(a, a);
    }
    return res;
}

struct segtree {
    int n;
    vector<long long> tr;

    segtree() = default;
    segtree(int n) : n(n), tr(vector<long long>(2 * n, 0)) {}

    void update(int k, long long x) {
        for (tr[k += n] = x; k; k >>= 1, tr[k] = tr[k << 1] + tr[k << 1 | 1]);
    }

    long long get(int l, int r) {
        int res = 0;
        for (l += n, r += n; l <= r; l >>= 1, r >>= 1) {
            if (l & 1) res += tr[l++];
            if (~r & 1) res += tr[r--];
        }
        return res;
    }
};

using ll = long long;

const int N = 1e6;
int fact[N], ifac[N];

int main() {
    cin.tie(0)->sync_with_stdio(0);

    fact[0] = 1;
    for (int i = 1; i < N; ++i) fact[i] = mul(fact[i - 1], i);
    ifac[N - 1] = binpow(fact[N - 1], mod - 2);
    for (int i = N - 2; i >= 0; --i) ifac[i] = mul(ifac[i + 1], i + 1);

    int n;
    cin >> n;
    vector<int> a(n);
    int cnt[3];
    cnt[0] = cnt[1]= cnt[2] = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        cnt[a[i] % 3]++;
    }
    if (cnt[1] == cnt[2]) {
        cout << 0;
        return 0;
    }
    if (abs(cnt[1] - cnt[2]) > 2) {
        cout << 0;
        return 0;
    }
    cout << mul(fact[cnt[0]], mul(fact[cnt[1]], mul(fact[cnt[2]], mul(fact[n - 1], mul(ifac[n - 1 - cnt[0]], ifac[cnt[0]])))));
}