#include <iostream>
#include <map>
#include <utility>
#include <algorithm>
#include <stdint.h>
#include <vector>

using namespace std;

uint32_t shrt(vector<vector<uint32_t>>& children, vector<uint32_t>& shortest, uint32_t v) {
	if (children[v].empty()) return 0;
	uint32_t r = UINT32_MAX;
	for (const auto& child : children[v]) {
		auto c = shrt(children, shortest, child) + 1;
		if (c < r) r = c;
	}
	shortest[v] = r;
	return r;
}

uint32_t count(vector<vector<uint32_t>>& children, vector<uint32_t>& shortest, uint32_t toLeaf, uint32_t v) {
	if (children[v].empty()) return 0;
	uint32_t r = 0;
	uint32_t addition = 0;
	if (toLeaf == 0) {
		//std::cout << shortest[0] << '\n';
		//std::cout << v << '\n';
		toLeaf = shortest[v];
		addition = 1;
	}
	for (const auto& child : children[v]) {
		auto c = count(children, shortest, toLeaf - 1, child) + addition;
		if (c > r) r = c;
	}
	return r;
}

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	uint32_t n;
	cin >> n;
	vector<int32_t> parent(n);
	vector<vector<uint32_t>> children(n);
	parent[0] = -1;
	for (uint32_t i = 1; i < n; i++) {
		std::cin >> parent[i];
		parent[i]--;
		children[parent[i]].push_back(i);
	}
	vector<uint32_t> shortest(n);
	shrt(children, shortest, 0);
	std::cout << count(children, shortest, 0, 0);
}
