#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define int ll


const int MOD = 1e9 + 7;

struct DSU {
    vector<int> gg;
    int cd = 0;
    DSU(int n) {
        gg.assign(n, -1);
        cd = n;
    }
    int gp(int v) {
        if (gg[v] < 0) return v;
        return gg[v] = gp(gg[v]);
    }
    void merge(int u, int v) {
//        cerr << u + 1 << ' ' << v + 1 << '\n';
//        cerr << u << ' ' << v << '\n';
        u = gp(u);
        v = gp(v);
        if (u == v) return;
        if (gg[u] < gg[v]) {
            swap(u, v);
        }
        if (gg[v] == -1)
            --cd;
        if (gg[u] == gg[v]) {
            --gg[v];
        }
        gg[u] = v;
    }
};

signed main() {
    cin.tie(0)->sync_with_stdio(0);

    int n;
    cin >> n;
    vector<int> x(n), y(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
    }
    DSU dsu(n - 1);
    vector<vector<tuple<ld, int, int>>> fg(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        int bx = x[v] - x[u];  // uv
        int by = y[v] - y[u];
        ld ang = atan2((ld) by, (ld) bx);
        ang += M_PI;
        fg[u].push_back({ang, i, v});
        fg[v].push_back({(ang < M_PI ? ang + M_PI : ang - M_PI), i, u});
    }
    for (int i = 0; i < n; ++i) {
        std::sort(fg[i].begin(), fg[i].end());
    }
    vector<set<int>> ok_edges(n);
    for (int u = 0; u < n; ++u) {
        for (const auto &[ang, eid, v] : fg[u]) {
            auto posv = std::lower_bound(fg[v].begin(), fg[v].end(), tuple<ld, int, int>{ang, 0, 0});
            vector<tuple<ld, int, int>>::iterator prv, nxt;
            if (posv == fg[v].end()) {
                prv = prev(posv);
                nxt = fg[v].begin();
            } else if ((get<0>(*posv) - ang) < 1e-10) {
                prv = nxt = posv;
            } else {
                nxt = posv;
                if (nxt == fg[v].begin()) {
                    prv = prev(fg[v].end());
                } else {
                    prv = prev(posv);
                }
            }
            vector<int> very_tmp;
            very_tmp.push_back(get<1>(*prv));
            very_tmp.push_back(get<1>(*nxt));
            for (int now : very_tmp) {
//                cerr << eid << ' ' << now << '\n';
                if (ok_edges[now].find(eid) == ok_edges[now].end()) {
                    ok_edges[eid].insert(now);
//                    cerr << ' ' << now << ' ' << eid << '\n';
                } else {
                    dsu.merge(eid, now);
                }
            }
//            if (u < v) {
//                cerr << eid << ' ' << get<1>(*prv) << ' ' << get<1>(*nxt) << '\n';
//                ok_edges[eid].insert(get<1>(*prv));
//                ok_edges[eid].insert(get<1>(*nxt));
//            } else {
//                set<int> slet;
//                if (ok_edges[eid].find(get<1>(*prv)) != ok_edges[eid].end()) {
//                    // slet.insert(get<1>(*prv));
//                    dsu.merge(get<1>(*prv), eid);
//                }
//                if (ok_edges[eid].find(get<1>(*nxt)) != ok_edges[eid].end()) {
//                    //  slet.insert(get<1>(*nxt));
//                    dsu.merge(get<1>(*nxt), eid);
//                }
////                ok_edges[eid] = slet;
//            }
        }
    }
    cout << dsu.cd << '\n';
}