#include <bits/stdc++.h>
using namespace std;
using ll = long long;

const int b2 = 'b' + 'b';

struct Node {
    bool full, no_f = true, no_l = true, no_fl = true;
    char f = '\0', l;
    int size = 0;

    bool kek(const Node &other, int sub1, int sub2) {
        if (size == sub1 && other.size == sub2) return true;
        if (size == sub1) return other.f != 'b';
        if (other.size == sub2) return l != 'b';
        return l != 'b' || other.f != 'b';
    }

    Node operator+(const Node &other) {
        if (f == '\0') return other;
        if (other.f == '\0') return *this;
        return Node {
            .full = (full && other.full) || (no_l && other.no_f && kek(other, 0, 0)),
            .no_f = (no_f && other.full) || (no_fl && other.no_f && kek(other, 1, 0)),
            .no_l = (full && other.no_l) || (no_l && other.no_fl && kek(other, 0, 1)),
            .no_fl = (no_f && other.no_l) || (no_fl && other.no_fl && kek(other, 1, 1)),
            .f = f,
            .l = other.l,
            .size = size + other.size
        };
    }
};

constexpr int R = 1 << 17;
Node tree[2 * R];

void build(string &s) {
    for (int i = R; i < R + s.size(); ++i) {
        tree[i] = Node{s[i - R] == 'a', true, true, true, s[i - R], s[i - R], 1};
    }
    for (int i = R - 1; i > 0; --i) {
        tree[i] = tree[2 * i] + tree[2 * i + 1];
    }
}

void update(int pos) {
    pos += R;
    tree[pos].full = !tree[pos].full;
    tree[pos].f ^= 3;  // 'b' ^ 'a'
    tree[pos].l ^= 3;
    for (pos /= 2; pos > 0; pos /= 2) {
        tree[pos] = tree[pos * 2] + tree[pos * 2 + 1];
    }
}

Node get(int l, int r) {
    Node ln, rn;
    ln.f = '\0';
    rn.f = '\0';
    l += R;
    r += R;
    while (l < r) {
        if (l & 1) {
            ln = ln + tree[l++];
        }
        if (r & 1) {
            rn = tree[--r] + rn;
        }
        l >>= 1;
        r >>= 1;
    }
    return ln + rn;
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    build(s);
    int q;
    cin >> q;
    while (q --> 0) {
        int t;
        cin >> t;
        if (t == 1) {
            int p;
            cin >> p;
            update(p - 1);
        } else {
            int l, r;
            cin >> l >> r;
            if (get(l - 1, r).full) {
                cout << "YES\n";
            } else {
                cout << "NO\n";
            }
        }
    }
}
