#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int N = 1e6 + 10, MOD = 1e9 + 7;
int f[N], inv_f[N];

int mul(int a, int b) {
    return 1ll * a * b % MOD;
}

int binpow(int a, int n) {
    int res = 1;
    while (n) {
        if (n & 1) {
            res = mul(res, a);
        }
        a = mul(a, a);
        n /= 2;
    }
    return res;
}

int inv(int a) {
    return binpow(a, MOD - 2);
}

int cnk(int n, int k) {
    if (k < 0 || k > n) return 0;
    return mul(f[n], mul(inv_f[k], inv_f[n - k]));
}

int solve(vector<int> cnt, int need) {
    if (cnt[need] == 0) return 0;
    int n = cnt[1] + cnt[2];
    int res = cnt[need];
    cnt[need]--;
    while (cnt[1] > 0 || cnt[2] > 0) {
        if (cnt[need] == 0) {
            cnt[need]--;
            break;
        }
        res = mul(res, cnt[need]);
        cnt[need]--;
        need = need ^ 1 ^ 2;
    }
    if (cnt[1] == 0 && cnt[2] == 0) {
        if (cnt[0] > 0 && n > 0) {
            res = mul(res, mul(f[cnt[0]], cnk(n + cnt[0] - 1, cnt[0])));
        }
        return res;
    } else {
        return 0;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    f[0] = inv_f[0] = 1;
    for (int i = 1; i < N; i++) {
        f[i] = mul(f[i - 1], i);
        inv_f[i] = inv(f[i]);
    }
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> cnt(3);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        cnt[a[i] % 3]++;
    }
    int ans = solve(cnt, 1) + solve(cnt, 2);
    cout << ans % MOD << endl;
    return 0;
}