#include <bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("lzcnt")
#pragma GCC target("popcnt")
#pragma GCC target("avx,avx2")
#define sz(x) (int)x.size()

using namespace std;

const int N = 2e5 + 1;
const int OO = 1e9;
vector<int> g[N];
int dst[N], h[N], dp[N];

void dfs(int v, int pr = -1) {
    if (pr != -1) {
        h[v] = h[pr] + 1;
        if (sz(g[v]) == 1) {
            dst[v] = 0;
            return;
        }
    }
    for (int &to : g[v]) {
        if (to == pr) continue;
        dfs(to, v);
        dst[v] = min(dst[v], dst[to] + 1);
    }
}

struct ST {
    int mx;
    int l;
    int r;
    ST *left;
    ST *right;

    ST(int l, int r) {
        mx = 0;
        this->l = l;
        this->r = r;
        left = nullptr;
        right = nullptr;
    }

    int get(int ql, int qr) {
        if (l > qr || r < ql) return -OO;
        if (l >= ql && r <= qr) return mx;
        int res = 0;
        if (left != nullptr) {
            res = max(res, left->get(ql, qr));
        }
        if (right != nullptr) {
            res = max(res, right->get(ql, qr));
        }
        return res;
    }

    void upd(int H, int v) {
        if (l == r) {
            mx = max(mx, v);
            return;
        }
        int m = l + r >> 1;
        if (H <= m) {
            if (left == nullptr) {
                left = new ST(l, m);
            }
            left->upd(H, v);
        } else {
            if (right == nullptr) {
                right = new ST(m + 1, r);
            }
            right->upd(H, v);
        }
        if (left != nullptr) {
            mx = max(mx, left->mx);
        }
        if (right != nullptr) {
            mx = max(mx, right->mx);
        }
    }

    void clear() {
        if (left != nullptr) {
            left->clear();
            delete left;
        }
        if (right != nullptr) {
            right->clear();
            delete right;
        }
    }
};

vector<pair<int, int>> hv[N];
ST *T[N];

void dfs2(int v, int pr = -1) {
    T[v] = new ST(0, N);
    if (sz(g[v]) == 1 && pr != -1) {
        dp[v] = 0;
        T[v]->upd(h[v], 0);
        hv[v].push_back({h[v], 0});
        return;
    }
    dp[v] = 1;
    for (int &to : g[v]) {
        if (sz(hv[v]) > 67000) {
            break;
        }
        if (to == pr) continue;
        dfs2(to, v);
        dp[v] = max(dp[v], dp[to]);
        if (sz(hv[v]) > sz(hv[to])) {
            swap(hv[v], hv[to]);
            swap(T[v], T[to]);
        }
        for (auto &parka : hv[to]) {
            T[v]->upd(parka.first, parka.second);
            hv[v].push_back(parka);
        }
        hv[to].clear();
        T[to]->clear();
    }
    dp[v] = max(dp[v], 1 + T[v]->get(h[v] + dst[v], N));
    hv[v].push_back({h[v], dp[v]});
    T[v]->upd(h[v], dp[v]);
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    fill(dst, dst + n + 1, OO);
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        g[i].push_back(p);
        g[p].push_back(i);
    }
    dfs(1);
    dfs2(1);
    cout << dp[1];
    return 0;
}
