#include <bits/stdc++.h>

using namespace std;

struct segtree {
    struct node {
        int lb, rb;
        int ln = -1, rn = -1;

        int odd = 0, even = 0, val = 0;

        node(int l, int r) : lb(l), rb(r) { }
    };

    vector<node> st;

    segtree() {
        st.push_back(node(0, 8));
    }

    void add(int k, bool odd, int x, int v = 0) {
        if (st[v].rb - st[v].lb == 1) {
            if (odd)
                st[v].odd += x;
            else
                st[v].even += x;
            st[v].val = max(st[v].even, st[v].odd);
            return;
        }

        int m = (st[v].lb + st[v].rb) / 2;
        if (k < m) {
            if (st[v].ln == -1) {
                st[v].ln = st.size();
                st.push_back(node(st[v].lb, m));
            }
            add(k, odd, x, st[v].ln);
            int rval = (st[v].rn == -1 ? 0 : st[st[v].rn].val);
            st[v].val = rval + st[st[v].ln].val;
        } else {
            if (st[v].rn == -1) {
                st[v].rn = st.size();
                st.push_back(node(m, st[v].rb));
            }
            add(k, odd, x, st[v].rn);
            int lval = (st[v].ln == -1 ? 0 : st[st[v].ln].val);
            st[v].val = lval + st[st[v].rn].val;
        }
    }

    int get() {
        return st[0].val;
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    segtree x1, x2, y1, y2;

    map<pair<int, int>, bool> mp;

    int q;
    cin >> q;
    while (q--) {
        int x, y;
        cin >> x >> y;
        --x;
        --y;

        if (y % 2) {
            x1.add(y / 2, x % 2, mp[{ x, y }] ? -1 : 1);
        } else {
            x2.add(y / 2, x % 2, mp[{ x, y }] ? -1 : 1);
        }

        if (x % 2) {
            y1.add(x, y % 2, mp[{ x, y }] ? -1 : 1);
        } else {
            y2.add(x, y % 2, mp[{ x, y }] ? -1 : 1);
        }

        mp[{ x, y }] ^= true;

        cout << max(max(x1.get(), x2.get()), max(y1.get(), y2.get())) << '\n';
    }

    return 0;
}
