#include <bits/stdc++.h>

using namespace std;
#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
using pii = pair <int, int>;

template <typename t1, typename t2>
void mxr(t1& a, const t2& b) {
    if (b > a) {
        a = b;
    }
};

struct Node {
    vector <int> ans;
    Node(char c) {
        if (c == 'a') {
            ans = {0, 2, 3, 3};
        }
        else if (c == 'b') {
            ans = {0, 0, 1, 2};
        }
        else {
            ans = {0, 1, 2, 3};
        }
    }
};

Node merge(Node a, Node b) {
    Node ans('a');
    for (int i = 0; i < 4; ++i) {
        ans.ans[i] = b.ans[a.ans[i]];
    }
    return ans;
}

struct Seg {
private:
    vector <Node> d;
    int n;

    void upd(int i) {
        d[i] = merge(d[2 * i], d[2 * i + 1]);
    }

    Node get(int ql, int qr, int l, int r, int i) {
        if (ql >= r || l >= qr || l >= r) {
            return Node{'c'};
        }
        if (l >= ql && r <= qr) {
            return d[i];
        }
        int m = (l + r) / 2;
        return merge(get(ql, qr, l, m, 2 * i),
                     get(ql, qr, m, r, 2 * i + 1));
    }

public:
    explicit Seg(const string& s) {
        n = 1;
        while (n < sz(s)) {
            n <<= 1;
        }
        d.resize(2 * n, 'c');
        for (int i = 0; i < sz(s); ++i) {
            d[i + n] = s[i];
        }
        for (int i = n - 1; i; --i) {
            upd(i);
        }
    }

    int get(int l, int r) {
        return get(l, r, 0, n, 1).ans[2];
    }

    void upd(int i, char c) {
        i += n;
        d[i] = Node(c);
        while ((i /= 2) > 0) {
            upd(i);
        }
    }
};

signed main() {
#ifdef BUY
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int n;
    cin >> n;
    string s;
    cin >> s;
    int q;
    cin >> q;
    Seg seg(s);
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int i;
            cin >> i;
            --i;
            char res = 'a' + ((s[i] - 'a') ^ 1);
            seg.upd(i, res);
            s[i] = res;
        } else {
            int l, r;
            cin >> l >> r;
            --l;
            if (seg.get(l, r) >= 2) cout << "YES\n";
            else cout << "NO\n";
        }
    }
}