#include "bits/stdc++.h"

using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("avx2")

//#define int long long
#define vec vector
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rend(), (a).rbegin()

template<typename t>
istream& operator>>(istream& in, vector<t>& v) {
    for (auto& u: v) in >> u;
    return in;
}

struct point {
    int x, y;
    point() = default;
    point(int _x, int _y): x(_x), y(_y) {}
};

istream& operator>>(istream& in, point& p) {
    in >> p.x >> p.y;
    return in;
}

struct vect {
    int x, y;
    vect() = default;
    vect(int _x, int _y): x(_x), y(_y) {}
    vect(point p1, point p2): x(p2.x - p1.x), y(p2.y - p1.y) {}
    vect(point p): x(p.x), y(p.y) {}
    int operator*(vect v) { return x * v.x + y * v.y; }
    int operator^(vect v) { return x * v.y - y * v.x; }
};

bool cmp(pair<vect, int> vv1, pair<vect, int> vv2) {
    auto v1 = vv1.first, v2 = vv2.first;
    bool f1 = v1.y > 0 || (v1.y == 0 && v1.x > 0);
    bool f2 = v2.y > 0 || (v2.y == 0 && v2.x > 0);
    if (f1) {
        if (f2) return (v1 ^ v2) > 0 || ((v1 ^ v2) == 0 && vv1.second < vv2.second);
        return true;
    }
    else {
        if (f2) return false;
        return (v1 ^ v2) > 0 || ((v1 ^ v2) == 0 && vv1.second < vv2.second);
    }
}

int n;
vector<vector<pair<int, int>>> g;
vector<vector<int>> gr;
vector<int> used;

void dfs(int v, int p) {
    for (auto& [u, ind]: g[v]) {
        if (u == p) {
            ind += n - 1;
            continue;
        }
        dfs(u, v);
    }
}

void calc(int v) {
    used[v] = 1;
    for (auto u: gr[v]) {
        if (!used[u]) calc(u);
    }
}

void solve () {
    cin >> n;
    vector<point> ps(n); cin >> ps;
    g.resize(n);
    for (int _ = 0; _ < n - 1; ++_) {
        int u, v; cin >> u >> v;
        --u, --v;
        g[u].emplace_back(v, _);
        g[v].emplace_back(u, _);
    }
    dfs(0, 0);
    vector<vector<pair<vect, int>>> srt(n);
    for (int v = 0; v < n; ++v) {
        for (auto [u, ind]: g[v]) srt[v].emplace_back(vect(ps[v], ps[u]), ind);
        sort(all(srt[v]), cmp);
    }
    int m = 2 * n - 2;
    gr.resize(m);
    vector<set<int>> tmp(m);
    for (int v = 0; v < n; ++v) {
        for (auto [u, ind]: g[v]) {
            vect vv(ps[v], ps[u]);
            int i = lower_bound(all(srt[u]), make_pair(vv, -1), cmp) - srt[u].begin();
            if (i < (int)srt[u].size() && (vv ^ srt[u][i].first) == 0) {
                if (abs(ind - srt[u][i].second) != n - 1) tmp[ind].insert(srt[u][i].second);
            }
            else {
                if (i < (int)srt[u].size() && abs(ind - srt[u][i].second) != n - 1) tmp[ind].insert(srt[u][i].second);
                if (i > 0 && abs(ind - srt[u][i - 1].second) != n - 1) tmp[ind].insert(srt[u][i - 1].second);
            }
        }
    }
    for (int v = 0; v < n; ++v) {
        for (auto u: tmp[v]) {
            if (tmp[(u + n - 1) % m].find((v + n - 1) % m) != tmp[(u + n - 1) % m].end()) {
                gr[v].push_back(u);
                gr[u].push_back(v);
            }
        }
    }
    used.assign(m, 0);
    int ans = 0;
    for (int i = 0; i < m; ++i) {
        if (!used[i]) calc(i), ans++;
    }
    cout << ans << ' ' << ans / 2;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}