#include <iostream>
#include<vector>
#include <algorithm>
#include <cmath>

using namespace std;
using ll = long long;
using vi = vector<ll>;

const long long nmax = 1005;

long long mas[nmax][nmax];
long long prefG[nmax];
long long prefV[nmax];

void solve() {
	long long n;
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= n; ++j) {
			cin >> mas[i][j];
		}
	}
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= n; ++j) {
			prefG[i] += mas[i][j];
		}
	}
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= n; ++j) {
			prefV[i] += mas[j][i];
		}
	}
	long long needSum = (n * (n * n + 1)) / 2;
	vector<long long> incorrG, incorrV;
	for (int i = 1; i <= n; ++i) {
		if (prefG[i] != needSum) {
			incorrG.push_back(i);
		}
		if (prefV[i] != needSum) {
			incorrV.push_back(i);
		}
	}
	if (incorrG.empty()) {
		long long str1 = incorrV[0], str2 = incorrV[1];
		for (int i = 1; i <= n; ++i) {
			if (prefV[str1] - mas[i][str1] + mas[i][str2] == needSum &&
				prefV[str2] - mas[i][str2] + mas[i][str1] == needSum) {
				cout << i << " " << str1 << "\n" << i << " " << str2 << "\n";
				return;
			}
		}
    }
	else if (incorrV.empty()) {
		long long str1 = incorrG[0], str2 = incorrG[1];
		for (int i = 1; i <= n; ++i) {
			if (prefG[str1] - mas[str1][i] + mas[str2][i] == needSum &&
				prefG[str2] - mas[str2][i] + mas[str1][i] == needSum) {
				cout << str1 << " " << i << "\n" << str2 << " " << i << "\n";
				return;
			}
		}
	}
	else {
		long long i = incorrG[0], i2 = incorrG[1];
		long long j = incorrV[0], j2 = incorrV[1];
		if (prefV[j2] - mas[i2][j2] + mas[i][j] == needSum &&
			prefG[i2] - mas[i2][j2] + mas[i][j] == needSum &&
			prefV[j] + mas[i2][j2] - mas[i][j] == needSum &&
			prefG[i] + mas[i2][j2] - mas[i][j] == needSum) {
			cout << i << " " << j << "\n" << i2 << " " << j2 << "\n";
			return;
		}
		if (prefV[j2] - mas[i][j2] + mas[i2][j] == needSum &&
			prefG[i] - mas[i][j2] + mas[i2][j] == needSum &&
			prefV[j] + mas[i][j2] - mas[i2][j] == needSum &&
			prefG[i2] + mas[i][j2] - mas[i2][j] == needSum) {
			cout << i << " " << j2 << "\n" << i2 << " " << j << "\n";
			return;
		}
	}
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(false);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}
