#include <bits/stdc++.h>

using namespace std;
#define int long long
using ll = long long;

bool check(vector<vector<int>> &v) {
    map<int, int> mp;
    int n = v.size();
    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < n; j++) {
            sum += v[i][j];
        }
        mp[sum]++;
    }
    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < n; j++) {
            sum += v[j][i];
        }
        mp[sum]++;
    }
    if (mp.size() == 1) {
        return true;
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;

    vector<vector<int>> a(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }

    if (n <= 8) {
        for (int x1 = 0; x1 < n; x1++) {
            for (int y1 = 0; y1 < n; y1++) {
                for (int x2 = 0; x2 < n; x2++) {
                    for (int y2 = 0; y2 < n; y2++) {
                        vector<vector<int>> v = a;
                        int tmp = v[x1][y1];
                        v[x1][y1] = v[x2][y2];
                        v[x2][y2] = tmp;
                        if (check(v)) {
                            cout << x1 + 1 << " " << y1 + 1 << "\n";
                            cout << x2 + 1 << " " << y2 + 1;
                            return 0;
                        }
                    }
                }
            }
        }
    }

    map<int, int> hui;
    vector<int> rows(n);
    vector<int> cols(n);
    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < n; j++) {
            sum += a[i][j];
        }
        rows[i] = sum;
        hui[sum]++;
    }

    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < n; j++) {
            sum += a[j][i];
        }
        cols[i] = sum;
        hui[sum]++;
    }

    int maxx_summ = 0;
    int maxx_cnt = 0;
    for (auto [sum, cnt]: hui) {
        if (cnt > maxx_cnt) {
            maxx_summ = sum;
            maxx_cnt = cnt;
        }
    }

    int first_i = -1;
    int second_i = -1;
    int first_j = -1;
    int second_j = -1;
    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < n; j++) {
            sum += a[i][j];
        }

        if (first_i == -1 and sum != maxx_summ) {
            first_i = i;
        } else if (sum != maxx_summ) {
            second_i = i;
        }
    }

    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < n; j++) {
            sum += a[j][i];
        }

        if (first_j == -1 and sum != maxx_summ) {
            first_j = i;
        } else if (sum != maxx_summ) {
            second_j = i;
        }
    }

    if (first_i == -1) {
        for (int i = 0; i < n; i++) {
            int first_sum = cols[first_j] - a[i][first_j] + a[i][second_j];
            int second_sum = cols[second_j] - a[i][second_j] + a[i][first_j];
            if (first_sum == maxx_summ and second_sum == maxx_summ) {
                cout << i + 1 << " " << first_j + 1 << " " << i + 1 << " " << second_j + 1;
                return 0;
            }
        }

        assert(false);
    }
    if (first_j == -1) {
        for (int i = 0; i < n; i++) {
            int first_sum = rows[first_i] - a[first_i][i] + a[second_i][i];
            int second_sum = rows[second_i] - a[second_i][i] + a[first_i][i];
            if (first_sum == maxx_summ and second_sum == maxx_summ) {
                cout << first_i + 1 << " " << i + 1 << " " << second_i + 1 << " " << i + 1;
                return 0;
            }
        }

//        assert(false);
    }

    vector<vector<int>> v = a;
    int tmp = v[first_i][first_j];
    v[first_i][first_j] = v[second_i][second_j];
    v[second_i][second_j] = tmp;

    vector<vector<int>> p = a;
    tmp = p[second_i][first_j];
    p[second_i][first_j] = p[first_i][second_j];
    p[first_i][second_j] = tmp;

    if (check(v)) {
        cout << first_i + 1 << " " << first_j + 1 << "\n" << second_i + 1 << " " << second_j + 1;
        return 0;
    } else if (check(p)) {
        cout << second_i + 1 << " " << first_j + 1 << "\n" << first_i + 1 << " " << second_j + 1;
    }

    return 0;
}