#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;

struct node {
    bool a00, a10, a01, a11;
    ll tl, tr;
};

struct segtree {
    ll n;
    vector<node> t;
    string s;

    segtree() {}

    segtree(string& ss) {
        n = ss.size();
        s = ss;
        t.resize(4 * n);
        build(0, 0, n - 1);
    }

    node merge(node a, node b) {
        if (a.tl == -INF) return b;
        if (b.tl == -INF) return a;
        ll len1 = a.tr - a.tl + 1, len2 = b.tr - b.tl + 1;
        bool a00 = ((a.a00 && b.a00) || (a.a01 && b.a10 && s[a.tr] != s[b.tl]));
        bool a01 = ((a.a00 && b.a01) || (a.a01 && b.a11 && s[a.tr] != s[b.tl] && len2 > 1));
        bool a10 = ((a.a10 && b.a00) || (a.a11 && b.a10 && s[a.tr] != s[b.tl] && len1 > 1));
        bool a11 = ((a.a10 && b.a01) || (a.a11 && b.a11 && s[a.tr] != s[b.tl] && len1 > 1 && len2 > 1));
        return {a00, a10, a01, a11, a.tl, b.tr};
    }

    void build(ll v, ll tl, ll tr) {
        if (tl == tr) {
            t[v].a00 = (s[tl] == 'a');
            t[v].a10 = true;
            t[v].a01 = true;
            t[v].a11 = true;
            t[v].tl = tl;
            t[v].tr = tr;
            return;
        }
        ll tm = (tl + tr) / 2;
        build(2 * v + 1, tl, tm);
        build(2 * v + 2, tm + 1, tr);
        t[v] = merge(t[2 * v + 1], t[2 * v + 2]);
    }

    node _get(ll v, ll tl, ll tr, ll l, ll r) {
        if (l <= tl && tr <= r) {
            return t[v];
        }
        if (tr < l || r < tl) {
            return {false, false, false, false, -INF, -INF};
        }
        ll tm = (tl + tr) / 2;
        return merge(_get(2 * v + 1, tl, tm, l, r), _get(2 * v + 2, tm + 1, tr, l, r));
    }

    void _upd(ll idx, ll v, ll tl, ll tr) {
        if (tl == idx && idx == tr) {
            if (s[idx] == 'a') s[idx] = 'b';
            else s[idx] = 'a';

            t[v].a00 = (s[tl] == 'a');
            t[v].a10 = true;
            t[v].a01 = true;
            t[v].a11 = true;
            t[v].tl = tl;
            t[v].tr = tr;
            return;
        }
        if (tr < idx || idx < tl) {
            return;
        }
        ll tm = (tl + tr) / 2;
        _upd(idx, 2 * v + 1, tl, tm);
        _upd(idx, 2 * v + 2, tm + 1, tr);
        t[v] = merge(t[2 * v + 1], t[2 * v + 2]);
    }

    node get(ll l, ll r) {
        return _get(0, 0, n - 1, l, r);
    }

    void upd(ll idx) {
        _upd(idx, 0, 0,n - 1);
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll n; cin >> n;
    string s; cin >> s;

    segtree t(s);
    ll q; cin >> q;
    while (q--) {
        char type; cin >> type;
        if (type == '1') {
            ll idx; cin >> idx;
            idx--;
            t.upd(idx);
        } else {
            ll l, r; cin >> l >> r;
            l--; r--;
            auto ans = t.get(l, r).a00;
            if (ans) cout << "YES" << '\n';
            else cout << "NO" << '\n';
        }
    }
}


//#include <bits/stdc++.h>
//
//using namespace std;
//using ll = long long;
//
//bool check(vector<vector<int>> &v) {
//    map<int, int> mp;
//    int n = v.size();
//    for (int i = 0; i < n; i++) {
//        int sum = 0;
//        for (int j = 0; j < n; j++) {
//            sum += v[i][j];
//        }
//        mp[sum]++;
//    }
//    for (int i = 0; i < n; i++) {
//        int sum = 0;
//        for (int j = 0; j < n; j++) {
//            sum += v[j][i];
//        }
//        mp[sum]++;
//    }
//    if (mp.size() == 1) {
//        return true;
//    }
//    return false;
//}
//
//int main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(0);
//
//    int n;
//    cin >> n;
//
//    vector<vector<int>> a(n, vector<int>(n));
//    for (int i = 0; i < n; i++) {
//        for (int j = 0; j < n; j++) {
//            cin >> a[i][j];
//        }
//    }
//
//    if (n <= 8) {
//        for (int x1 = 0; x1 < n; x1++) {
//            for (int y1 = 0; y1 < n; y1++) {
//                for (int x2 = 0; x2 < n; x2++) {
//                    for (int y2 = 0; y2 < n; y2++) {
//                        vector<vector<int>> v = a;
//                        int tmp = v[x1][y1];
//                        v[x1][y1] = v[x2][y2];
//                        v[x2][y2] = tmp;
//                        if (check(v)) {
//                            cout << x1 + 1 << " " << y1 + 1 << "\n";
//                            cout << x2 + 1 << " " << y2 + 1;
//                            return 0;
//                        }
//                    }
//                }
//            }
//        }
//    }
//
//    map<int, int> hui;
//    vector<int> rows(n);
//    vector<int> cols(n);
//    for (int i = 0; i < n; i++) {
//        int sum = 0;
//        for (int j = 0; j < n; j++) {
//            sum += a[i][j];
//        }
//        rows[i] = sum;
//        hui[sum]++;
//    }
//
//    for (int i = 0; i < n; i++) {
//        int sum = 0;
//        for (int j = 0; j < n; j++) {
//            sum += a[j][i];
//        }
//        cols[i] = sum;
//        hui[sum]++;
//    }
//
//    int maxx_summ = 0;
//    int maxx_cnt = 0;
//    for (auto [sum, cnt]: hui) {
//        if (cnt > maxx_cnt) {
//            maxx_summ = sum;
//            maxx_cnt = cnt;
//        }
//    }
//
//    int first_i = -1;
//    int second_i = -1;
//    int first_j = -1;
//    int second_j = -1;
//    for (int i = 0; i < n; i++) {
//        int sum = 0;
//        for (int j = 0; j < n; j++) {
//            sum += a[i][j];
//        }
//
//        if (first_i == -1 and sum != maxx_summ) {
//            first_i = i;
//        } else if (sum != maxx_summ) {
//            second_i = i;
//        }
//    }
//
//    for (int i = 0; i < n; i++) {
//        int sum = 0;
//        for (int j = 0; j < n; j++) {
//            sum += a[j][i];
//        }
//
//        if (first_j == -1 and sum != maxx_summ) {
//            first_j = i;
//        } else if (sum != maxx_summ) {
//            second_j = i;
//        }
//    }
//
//    if (second_i == -1) {
//        cout << first_i + 1 << " " << first_j + 1 << "\n" << first_i + 1 << " " << second_j + 1;
//        return 0;
//    }
//    if (second_j == -1) {
//        cout << first_i + 1 << " " << first_j + 1 << "\n" << second_i + 1 << " " << first_j + 1;
//        return 0;
//    }
//
//    if (rows[first_i] - a[first_i][first_j] + a[second_i][second_j] == maxx_summ &&
//        cols[first_j] - a[first_i][first_j] + a[second_i][second_j] == maxx_summ) {
//        cout << first_i + 1 << " " << first_j + 1 << "\n" << second_i + 1 << " " << second_j + 1;
//        return 0;
//    } else {
//        cout << second_i + 1 << " " << first_j + 1 << "\n" << first_i + 1 << " " << second_j + 1;
//    }
//
//    return 0;
//}