#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll

#define vc vector

const int MAXN = 1e5 + 228, R = 1 << 17;

struct Fenwick {
    vector<int> t;

    Fenwick() {
        t.resize(MAXN, 0);
    }

    void add(int i) {
        for (; i < t.size(); i += i & -i) t[i]++;
    }

    void del(int i) {
        for (; i < t.size(); i += i & -i) t[i]--;
    }

    int get(int len) {
        int ans = 0;
        for (; len > 0; len -= len & -len) ans += t[len];
        return ans;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

struct Node {
    vector<int> pref, suf;

    int bpref, bsuf, mxb;
    int len;

    string res_s;

    bool res;

    Node() {
        res = false;
        len = 0;
        bpref = 0, bsuf = 0;
        mxb = 0;
        pref.resize(5, false), suf.resize(5, false);
    }
};

const string KAIF = "bbabb";

struct Tree {
    vector<Node> t;

    Node merge(const Node &l, const Node &r) {
        Node ans;
        for (int i = 0; i < 5; ++i) {
            ans.res |= l.res, ans.res |= r.res;
            ans.pref[i] |= l.pref[i];
            ans.suf[i] |= r.suf[i];
        }
        ans.mxb = max(l.mxb, r.mxb);
        ans.len = l.len + r.len;
        if (l.bpref == l.len) {
            ans.mxb = max(ans.mxb, l.bpref + r.bpref);
            ans.bpref = l.bpref + r.bpref;
        } else {
            ans.bpref = l.bpref;
        }
        if (r.bsuf == r.len) {
            ans.mxb = max(ans.mxb, r.bsuf + l.bsuf);
            ans.bsuf = r.len + l.bsuf;
        } else {
            ans.bsuf = r.bsuf;
        }
        if (l.len <= 5) {
            ans.res_s = l.res_s + r.res_s;
            for (int i = 0; i + 1 < 5; ++i) {
                ans.res |= (l.pref[i] & r.suf[i + 1]);
            }
            for (int i = 0; i < 5 && KAIF[i] == ans.res_s[i]; ++i) {
                ans.pref[i] = 1;
            }
            for (int i = ans.res_s.size() - 1, j = 4; i >= 0 && j >= 0 && KAIF[j] == ans.res_s[i]; --i, --j) {
                ans.suf[i] = 1;
            }
        }
        return ans;
    }

    Tree(string s) {
        t.resize(R * 2);
        s.erase(s.begin());
        for (int i = 0; i < s.size(); ++i) {
            t[i + R].res_s += s[i];
            if (s[i] == 'b') {
                t[i + R].pref[0] = t[i + R].suf[4] = 1;
            }
            t[i + R].len = 1;
        }
        for (int i = R - 1; i > 0; --i) {
            t[i] = merge(t[i * 2], t[i * 2 + 1]);
        }
    }

    Node get(int ql, int qr, int node = 1, int nl = 1, int nr = R) {
        if (ql <= nl && nr <= qr) {
            return t[node];
        }
        if (qr < nl || nr < ql) {
            return Node();
        }
        int nm = (nr + nl) / 2;
        return merge(get(ql, qr, node * 2, nl, nm), get(ql, qr, node * 2 + 1, nm + 1, nr));
    }

    bool check(int ql, int qr) {
        Node ans = get(ql, qr);
        if (ans.mxb >= 3 || ans.res) return false;
        return true;
    }

    void update(int i, char nv) {
        i += R - 1;
        t[i].res_s.clear(), t[i].res_s += nv;
        t[i].pref[0] = t[i].suf[4] = (nv == 'b');
        i /= 2;
        while (i) {
            t[i] = merge(t[i * 2], t[i * 2 + 1]);
            i /= 2;
        }
    }
};

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n;
    cin >> n;
    string s;
    cin >> s;
    s.insert(s.begin(), '*');
    Tree tree(s);
    int q;
    cin >> q;
    Fenwick cnta;
    for (int i = 1; i <= n; ++i) {
        if (s[i] == 'a') {
            cnta.add(i);
        }
    }
    auto upd = [&](int i) -> void {
        if (s[i] == 'a') cnta.del(i), s[i] = 'b';
        else cnta.add(i), s[i] = 'a';
        tree.update(i, s[i]);
    };
    while (q--) {
        int tp;
        cin >> tp;
        if (tp == 1) {
            int i;
            cin >> i;
            upd(i);
        } else {
            int l, r;
            cin >> l >> r;
            int cna = cnta.get(l, r), cnb = (r - l + 1) - cna;
            if (cnb > cna) {
                cout << "NO\n";
                continue;
            }
            bool f = tree.check(l, r);
            if (r - l + 1 >= 3 && s.substr(l, 3) == "bba") {
                f = false;
            }
            if (r - l + 1 >= 3 && s[r] == 'b' && s[r - 1] == 'b' && s[r - 2] == 'b') {
                f = false;
            }
            cout << (f ? "YES" : "NO") << "\n";
        }
    }
}