#include <bits/stdc++.h>

#define int long long
#define sz(a) (int)a.size()
using namespace std;

const int INF  = 1e9, MAXN = (1 << 18), mod = 1e9 + 7;
struct segtree{
    struct node{
        string s = "";
        bool pref = false;
        bool suf = false;
        bool all = true;
        bool ans = false;
        int prefb = 0;
        int sufb = 0;
        int allb = 0;
    };
    vector<node> tree;
    int k;
    segtree(int n){
        k=1;
        while(k<n){
            k*=2;
        }
        tree.resize(2*k-1);
    }
    node merge(node a, node b){
        if(a.s.empty()){
            return b;
        }
        if(b.s.empty()){
            return a;
        }
        node ans;
        ans.s = a.s+b.s;
        ans.all = false;
        ans.pref = a.pref;
        ans.suf = b.suf;
        ans.ans = a.ans || b.ans;
        if(a.all && b.all && a.s[sz(a.s)-1] != b.s[0]){
            ans.all = true;
        }
        if(a.all && b.s[0]=='b' && a.s[sz(a.s)-1]=='b'){
            ans.pref = true;
        }
        if(b.all && b.s[0]=='b' && a.s[sz(a.s)-1]=='b'){
            ans.suf = true;
        }
        if(a.suf && b.all && (a.s[sz(a.s)-1] != 'a' || b.s[0] != 'a')){
            ans.suf = true;
        }
        if(a.suf && a.s[sz(a.s)-1]=='b' && b.s[0]=='b'){
            ans.ans = true;
        }
        if(b.pref && a.s[sz(a.s)-1]=='b' && b.s[0]=='b'){
            ans.ans = true;
        }
        if(b.pref && a.all && (a.s[sz(a.s)-1] != 'a' || b.s[0] != 'a')){
            ans.pref = true;
        }
        if(a.suf && b.pref){
            if(a.s[sz(a.s)-1]!='a' || b.s[sz(b.s)-1]!='a'){
                ans.ans = true;
            }
        }

        ans.prefb = a.prefb;
        if(a.prefb == sz(a.s)){
            ans.prefb += b.prefb;
        }
        ans.sufb = b.sufb;
        if(b.sufb == sz(b.s)){
            ans.sufb += a.sufb;
        }
        ans.allb = max(max(a.allb, b.allb), a.sufb+b.prefb);
        if(ans.allb >=3){
            ans.ans = true;
        }
        return ans;
    }
    void set(int id, string c){
        set(id, c, 0,0,k);
    }
    void set(int id, string c, int x, int lx, int rx){
        if(lx>id || rx<=id){
            return;
        }
        if(rx-lx==1){
            tree[x].s = c;
            return;
        }
        int m = (lx+rx)/2;
        set(id, c, 2*x+1, lx,m);
        set(id, c, 2*x+2, m, rx);
        tree[x]=merge(tree[2*x+1], tree[2*x+2]);
    }
    bool get(int l, int r){
        node ans = get(l,r,0,0,k);
        return ans.ans;
    }
    node get(int l, int r, int x, int lx, int rx){
        if(l>=rx || r<=lx){
            node ans;
            ans.all = false;
            return ans;
        }
        if(lx>=l && rx<=r){
            return tree[x];
        }
        int m = (lx+rx)/2;
        return merge(get(l,r,2*x+1,lx,m), get(l,r,2*x+2, m,rx));
    }
};

void solve() {
    int n;
    cin>>n;
    string s;
    cin>>s;
    s = "b"+s+"b";
    segtree sg(n+2);
    for(int i = 0; i < n+2; i++){
        string hu = " ";
        hu[0] = s[i];
        sg.set(i,hu);
    }
    int q;
    cin>>q;
    for(int i = 0; i < q; i++){
        int t;
        cin>>t;
        if(t==2){
            int l, r;
            cin>>l>>r;
            r++;
            char c1 = s[l-1];
            char c2 = s[r];
            sg.set(l-1,"b");
            sg.set(r,"b");
            if(sg.get(l-1,r+1)){
                cout<<"NO"<<endl;
            }
            else{
                cout<<"YES"<<endl;
            }
            string hu = " ";
            hu[0] = c1;
            sg.set(l-1,hu);
            hu[0] = c2;
            sg.set(r,hu);
        }
        else{
            int id;
            cin>>id;
            char c = s[id];
            if(c=='a'){
                c='b';
            }
            else{
                c='a';
            }
            s[id]=c;
            string hu = " ";
            hu[0]=c;
            sg.set(id,hu);
        }
    }
}

signed main() {
#ifdef home
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }
}